From 0d988f887da7c152ea9e418ce96896e548276093 Mon Sep 17 00:00:00 2001
From: Rob Crittenden <rcritten@redhat.com>
Date: Jan 14 2026 18:32:07 +0000
Subject: [PATCH 5/6] Implement more PQ testing for both NSS and OpenSSL


This adds keyiread and csrgen tests for both NSS and
OpenSSL. keyiread, keygen and csrgen will now run by
default when PQ is enabled.

It also fixes the 028-dbus test if PQ is not enabled either
by configuration (--disable-ml-dsa) or because it isn't
available.

---

diff --git a/src/csrgen-o.c b/src/csrgen-o.c
index f1091c5..e1f8c4a 100644
--- a/src/csrgen-o.c
+++ b/src/csrgen-o.c
@@ -191,6 +191,7 @@ cm_csrgen_o_main(int fd, struct cm_store_ca *ca, struct cm_store_entry *entry,
 	unsigned int bmpcount, mdlen;
 	long error;
 	int i;
+	const EVP_MD *sign_md = cm_prefs_ossl_sig_alg(entry->cm_key_type.cm_key_algorithm);
 
 	status = fdopen(fd, "w");
 	if (status == NULL) {
@@ -344,8 +345,15 @@ cm_csrgen_o_main(int fd, struct cm_store_ca *ca, struct cm_store_entry *entry,
 							  upassword,
 							  strlen(password));
 			}
-			X509_REQ_sign(req, pkey, cm_prefs_ossl_hash());
-			PEM_write_X509_REQ(status, req);
+
+			if (X509_REQ_sign(req, pkey, sign_md) == 0) {
+				cm_log_errors(1, "Error signing the CSR.\n");
+				_exit(CM_SUB_STATUS_ERROR_AUTH); /* XXX */
+			}
+			if (PEM_write_X509_REQ(status, req) != 1) {
+				cm_log_errors(1, "Error while writing the CSR PEM.\n");
+				_exit(CM_SUB_STATUS_ERROR_AUTH); /* XXX */
+			}
 			/* Generate the SPKAC. */
 			memset(&spkac, 0, sizeof(spkac));
 			spkac.challenge = util_ASN1_IA5STRING_new();
@@ -362,7 +370,9 @@ cm_csrgen_o_main(int fd, struct cm_store_ca *ca, struct cm_store_entry *entry,
 			util_NETSCAPE_SPKI_set_sig_alg(&spki, sig_alg);
 			spki.signature = util_ASN1_BIT_STRING_new();
 			NETSCAPE_SPKI_set_pubkey(&spki, pkey);
-			NETSCAPE_SPKI_sign(&spki, pkey, cm_prefs_ossl_hash());
+			if (NETSCAPE_SPKI_sign(&spki, pkey, sign_md) == 0) {
+				cm_log_errors(1, "NETSCAPE_SPKI_sign failed.\n");
+			}
 			s = NETSCAPE_SPKI_b64_encode(&spki);
 			if (s != NULL) {
 				fprintf(status, "%s", s);
@@ -429,7 +439,9 @@ cm_csrgen_o_main(int fd, struct cm_store_ca *ca, struct cm_store_entry *entry,
 			}
 			X509_set_serialNumber(minicert, serial);
 			X509_set_pubkey(minicert, pkey);
-			X509_sign(minicert, pkey, cm_prefs_ossl_hash());
+			if (X509_sign(minicert, pkey, sign_md) == 0) {
+				cm_log_errors(1, "Signing minicert failed.\n");
+			}
 			len = i2d_X509(minicert, NULL);
 			mcb64 = NULL;
 			if (len > 0) {
diff --git a/src/prefs-n.c b/src/prefs-n.c
index 584bdd7..d080f0a 100644
--- a/src/prefs-n.c
+++ b/src/prefs-n.c
@@ -19,7 +19,9 @@
 
 #include <nss.h>
 #include <nss.h>
+#include <keyhi.h>
 #include <keythi.h>
+#include <pk11pub.h>
 #include <secoidt.h>
 
 #include "prefs.h"
@@ -114,6 +116,45 @@ cm_prefs_nss_sig_alg(SECKEYPrivateKey *pkey)
 			return SEC_OID_ANSIX962_ECDSA_SHA256_SIGNATURE;
 			break;
 		}
+#ifdef CM_ENABLE_ML_DSA
+	case mldsaKey:
+		/* This is a simplified version of
+		 * cm_GetSignatureAlgorithmFromPrivateKey from keyiread-n.c.
+		 * Once the NSS function is exported that can be moved to
+		 * something like util-n.c and be generalized. For now I
+		 * duplicate.
+		 */
+		SECItem item;
+		CK_ULONG paramSet;
+		SECStatus rv;
+
+		rv = PK11_ReadRawAttribute(PK11_TypePrivKey, pkey, CKA_PARAMETER_SET, &item);
+		if (rv != SECSuccess) {
+			return SEC_OID_UNKNOWN;
+		}
+
+		if (item.len != sizeof(paramSet)) {
+			PORT_Free(item.data);	
+			PORT_SetError(SEC_ERROR_INVALID_KEY);
+			return SEC_OID_UNKNOWN;
+		}
+		paramSet = *(CK_ULONG *)item.data;
+		PORT_Free(item.data);
+		switch (paramSet) {
+		case CKP_ML_DSA_44:
+			return SEC_OID_ML_DSA_44_SIGNATURE;
+			break;
+		case CKP_ML_DSA_65:
+			return SEC_OID_ML_DSA_65_SIGNATURE;
+			break;
+		case CKP_ML_DSA_87:
+			return SEC_OID_ML_DSA_87_SIGNATURE;
+			break;
+		default:
+			return SEC_OID_UNKNOWN;
+			break;
+		}
+#endif
 	default:
 		return SEC_OID_UNKNOWN;
 		break;
diff --git a/src/prefs-o.c b/src/prefs-o.c
index 4b6ef6f..39cabb7 100644
--- a/src/prefs-o.c
+++ b/src/prefs-o.c
@@ -32,6 +32,39 @@
 #include "prefs.h"
 #include "prefs-o.h"
 #include "util-o.h"
+#include "log.h"
+#include "store-int.h"
+
+const EVP_MD *
+cm_prefs_ossl_sig_alg(enum cm_key_algorithm cm_key_algorithm)
+{
+	switch(cm_key_algorithm) {
+	case cm_key_rsa:
+#ifdef CM_ENABLE_DSA
+	case cm_key_dsa:
+#endif
+#ifdef CM_ENABLE_EC
+	case cm_key_ecdsa:
+#endif
+		return cm_prefs_ossl_hash();
+		break;
+#ifdef CM_ENABLE_ML_DSA
+	case cm_key_ml_dsa_44:
+		return EVP_get_digestbyname("ML-DSA-44");
+		break;
+	case cm_key_ml_dsa_65:
+		return EVP_get_digestbyname("ML-DSA-65");
+		break;
+	case cm_key_ml_dsa_87:
+		return EVP_get_digestbyname("ML-DSA-87");
+		break;
+#endif
+	default:
+		cm_log(1, "Unknown or unsupported key type.\n");
+		return NULL;
+		break;
+	}
+}
 
 const EVP_MD *
 cm_prefs_ossl_hash_by_pref(enum cm_prefs_digest digest)
diff --git a/src/prefs-o.h b/src/prefs-o.h
index 1dcd4e8..9c233ab 100644
--- a/src/prefs-o.h
+++ b/src/prefs-o.h
@@ -18,6 +18,7 @@
 #ifndef cmprefso_h
 #define cmprefso_h
 
+const EVP_MD * cm_prefs_ossl_sig_alg(enum cm_key_algorithm cm_key_algorithm);
 const EVP_CIPHER *cm_prefs_ossl_cipher(void);
 const EVP_CIPHER *cm_prefs_ossl_cipher_by_pref(enum cm_prefs_cipher cipher);
 const EVP_MD *cm_prefs_ossl_hash(void);
diff --git a/tests/001-keyiread-mldsa/run.sh b/tests/001-keyiread-mldsa/run.sh
new file mode 100755
index 0000000..9c01c2f
--- /dev/null
+++ b/tests/001-keyiread-mldsa/run.sh
@@ -0,0 +1,36 @@
+#!/bin/bash -e
+
+cd "$tmpdir"
+
+source "$srcdir"/functions
+initnssdb "$tmpdir"
+
+for size in ML-DSA-44 ML-DSA-65 ML-DSA-87 ; do
+	# Generate a self-signed cert.
+	run_certutil -d "$tmpdir" -S -n keyi$size \
+		-s "cn=T$size" -c "cn=T$size" \
+		-x -t u -k mldsa -q $size
+	# Check the size of the key.
+	cat > entry.nss.$size <<- EOF
+	key_storage_type=NSSDB
+	key_storage_location=$tmpdir
+	key_nickname=keyi$size
+	EOF
+	$toolsdir/keyiread entry.nss.$size
+	# Export the key.
+	if ! pk12util -C AES-128-CBC -c AES-128-CBC -d "$tmpdir" -o $size.p12 -W "" -n "keyi$size" > /dev/null 2>&1 ; then
+		echo Error exporting key for $size, continuing.
+		continue
+	fi
+	if ! openssl pkcs12 -in $size.p12 -out key.$size -passin pass: -nodes -nocerts > /dev/null 2>&1 ; then
+		echo Error parsing exported key for $size, continuing.
+		continue
+	fi
+	cat > entry.openssl.$size <<- EOF
+	key_storage_type=FILE
+	key_storage_location=$tmpdir/key.$size
+	key_nickname=keyi$size
+	EOF
+	$toolsdir/keyiread entry.openssl.$size
+done
+echo Test complete.
diff --git a/tests/002-keygen-mldsa/prequal.sh b/tests/002-keygen-mldsa/prequal.sh
new file mode 100644
index 0000000..d146a65
--- /dev/null
+++ b/tests/002-keygen-mldsa/prequal.sh
@@ -0,0 +1,5 @@
+#!/bin/sh
+if test `id -u` -eq 0 ; then
+	echo "This test won't work right if run as root."
+	exit 1
+fi
diff --git a/tests/002-keygen-mldsa/run.sh b/tests/002-keygen-mldsa/run.sh
new file mode 100755
index 0000000..6631717
--- /dev/null
+++ b/tests/002-keygen-mldsa/run.sh
@@ -0,0 +1,84 @@
+#!/bin/bash -e
+
+cd "$tmpdir"
+
+source "$srcdir"/functions
+initnssdb "$tmpdir"
+
+cd "$tmpdir"
+
+source "$srcdir"/functions
+initnssdb "$tmpdir"
+
+for size in 44 65 87 ; do
+	echo "[nss:$size]"
+	# Generate a key.
+	cat > entry.$size <<- EOF
+	key_storage_type=NSSDB
+	key_storage_location=$tmpdir
+	key_nickname=keyi$size
+	key_gen_size=$size
+	key_gen_type=ML-DSA-$size
+	EOF
+	$toolsdir/keygen entry.$size
+	# Read the type and size.
+	sed -i 's,^key_gen_size.*,,g' entry.$size
+	$toolsdir/keyiread entry.$size
+done
+
+echo "[nss:rosubdir]"
+cat > entry.$size <<- EOF
+key_storage_type=NSSDB
+key_storage_location=$tmpdir/rosubdir
+key_nickname=keyi$size
+key_gen_size=$size
+key_gen_type=ML-DSA-$size
+EOF
+$toolsdir/keygen entry.$size || true
+
+echo "[nss:rwsubdir]"
+cat > entry.$size <<- EOF
+key_storage_type=NSSDB
+key_storage_location=$tmpdir/rwsubdir
+key_nickname=keyi$size
+key_gen_size=$size
+key_gen_type=ML-DSA-$size
+EOF
+$toolsdir/keygen entry.$size || true
+
+for size in 44 65 87 ; do
+	echo "[openssl:$size]"
+	# Generate a key.
+	cat > entry.$size <<- EOF
+	key_storage_type=FILE
+	key_storage_location=$tmpdir/sample.$size
+	key_gen_size=$size
+	key_gen_type=ML-DSA-$size
+	EOF
+	$toolsdir/keygen entry.$size
+	# Read the size.
+	sed -i 's,^key_gen_size.*,,g' entry.$size
+	$toolsdir/keyiread entry.$size
+done
+
+echo "[openssl:rosubdir]"
+cat > entry.$size <<- EOF
+key_storage_type=FILE
+key_storage_location=$tmpdir/rosubdir/sample.$size
+key_gen_size=$size
+key_gen_type=ML-DSA-$size
+EOF
+$toolsdir/keygen entry.$size || true
+
+echo "[openssl:rwsubdir]"
+cat > entry.$size <<- EOF
+key_storage_type=FILE
+key_storage_location=$tmpdir/rwsubdir/sample.$size
+key_gen_size=$size
+key_gen_type=ML-DSA-$size
+EOF
+touch $tmpdir/rwsubdir/sample.$size
+chmod u-w $tmpdir/rwsubdir/sample.$size
+$toolsdir/keygen entry.$size || true
+
+echo Test complete.
diff --git a/tests/003-csrgen-mldsa/run.sh b/tests/003-csrgen-mldsa/run.sh
new file mode 100755
index 0000000..0dc0720
--- /dev/null
+++ b/tests/003-csrgen-mldsa/run.sh
@@ -0,0 +1,52 @@
+#!/bin/bash -e
+
+cd "$tmpdir"
+
+source "$srcdir"/functions
+initnssdb "$tmpdir"
+
+size=ML-DSA-65
+
+# Build a self-signed certificate.
+run_certutil -d "$tmpdir" -S -n keyi$size \
+	-s "cn=T$size" -c "cn=T$size" \
+	-x -t u -k mldsa -q $size
+# Export the key.
+pk12util -C AES-128-CBC -c AES-128-CBC -d "$tmpdir" -o $size.p12 -W "" -n "keyi$size" > /dev/null 2>&1
+openssl pkcs12 -in $size.p12 -out key.$size -passin pass: -nodes -nocerts > /dev/null 2>&1 | ( grep -v '^MAC verified OK$' || : )
+# Read the public key and cache it.
+cat > entry.openssl.$size <<- EOF
+key_storage_type=FILE
+key_storage_location=$tmpdir/key.$size
+key_nickname=keyi$size
+id=keyi$size
+EOF
+$toolsdir/keyiread entry.openssl.$size > /dev/null 2>&1
+# Add the cached value to the prepping for the NSS copy.
+cat > entry.nss.$size <<- EOF
+key_storage_type=NSSDB
+key_storage_location=$tmpdir
+key_nickname=keyi$size
+id=keyi$size
+EOF
+# Generate a new CSR for that certificate's key.
+$toolsdir/csrgen entry.nss.$size > csr.nss.$size
+grep ^spkac= entry.nss.$size | sed s,spkac,SPKAC, > spkac.nss.$size
+# Generate a new CSR using the extracted key.
+$toolsdir/csrgen entry.openssl.$size > csr.openssl.$size
+grep ^spkac= entry.openssl.$size | sed s,spkac,SPKAC, > spkac.openssl.$size
+# Pull out the mini-cert.
+grep ^minicert= entry.openssl.$size | sed s,^minicert=,, | base64 -d > minicert.openssl.$size
+openssl x509 -out minicert.openssl.$size.pem -in minicert.openssl.$size -inform der
+grep ^minicert= entry.nss.$size | sed s,^minicert=,, | base64 -d > minicert.nss.$size
+openssl x509 -out minicert.nss.$size.pem -in minicert.nss.$size -inform der
+# The RSA tests already verify the contents of the requests, so we really only
+# need to care about the signatures passing verification.
+openssl req   -verify -noout -in csr.nss.$size 2>&1 | sed 's/Certificate request self-signature //'
+openssl req   -verify -noout -in csr.openssl.$size 2>&1 | sed 's/Certificate request self-signature //'
+openssl spkac -verify -noout < spkac.nss.$size 2>&1
+openssl spkac -verify -noout < spkac.openssl.$size 2>&1
+openssl verify -CAfile minicert.openssl.$size.pem minicert.openssl.$size.pem 2>&1
+openssl verify -CAfile minicert.nss.$size.pem minicert.nss.$size.pem 2>&1
+
+echo Test complete.
